<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: recursiveHierarchSearch.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('recursive_hierarch_search_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">recursiveHierarchSearch.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="recursive_hierarch_search_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef bsoncxxType</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">    #define bsoncxxType</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/array.hpp&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/document.hpp&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/kvp.hpp&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/array.hpp&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/document.hpp&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/stream/helpers.hpp&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/types.hpp&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/stdx/string_view.hpp&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/json.hpp&gt;</span> </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/types.hpp&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/builder/basic/document.hpp&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/json.hpp&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/document/value.hpp&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">        #include &lt;bsoncxx/stdx/string_view.hpp&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#endif </span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">   24</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(std::vector&lt;std::vector&lt;std::string&gt;&gt; matrix, <span class="keywordtype">unsigned</span> colNo)</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;{</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    std::vector&lt;std::string&gt; result_vec;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::vector&lt;std::string&gt;&gt;::iterator it=matrix.begin();it!=matrix.end();it++)</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    {</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        std::vector&lt;std::string&gt; vec = *it;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">if</span>((colNo+1)&lt;=vec.size() &amp;&amp; vec.size()&gt;0)</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        {</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            std::string el = vec[colNo];</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            result_vec.push_back(el);            </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        }        </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    }</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordflow">return</span> result_vec;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;}</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">   40</a></span>&#160;std::string <a class="code" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a>(std::string AddrStr,std::string attr)</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;{</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    std::vector&lt;std::string&gt; collector;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(AddrStr);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    bsoncxx::document::element el = mdx_bdocview[attr];</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;   </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    std::string result;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordflow">if</span>(tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        result = el.get_utf8().value.to_string();           </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="structutf8__document__type.html">   56</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;{   </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="structutf8__document__type.html#a44cd9702f7da1032eb73d2cbba0b2172">   58</a></span>&#160;    std::string <a class="code" href="structutf8__document__type.html#a44cd9702f7da1032eb73d2cbba0b2172">key</a>;</div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="structutf8__document__type.html#a293d926c3dedbf2179e331b39eda723a">   59</a></span>&#160;    std::string <a class="code" href="structutf8__document__type.html#a293d926c3dedbf2179e331b39eda723a">value</a>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;} <a class="code" href="structutf8__document__type.html">utf8_document_type</a>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="structutf8__document__array__type.html">   62</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;{   </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="structutf8__document__array__type.html#a248b65a1fe0fe9802d7c6cfe8f3a4eec">   64</a></span>&#160;    std::vector&lt;utf8_document_type&gt; <a class="code" href="structutf8__document__array__type.html#a248b65a1fe0fe9802d7c6cfe8f3a4eec">documents</a>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;} <a class="code" href="structutf8__document__array__type.html">utf8_document_array_type</a>;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="structchained__utf8doc__array__type.html">   67</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;{   </div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="structchained__utf8doc__array__type.html#a04fbde65e52c36fce726cb1476718171">   69</a></span>&#160;    std::vector&lt;utf8_document_array_type&gt; <a class="code" href="structchained__utf8doc__array__type.html#a04fbde65e52c36fce726cb1476718171">documents_chain</a>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;} <a class="code" href="structchained__utf8doc__array__type.html">chained_utf8doc_array_type</a>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#ae01709f428082a54dabe6a9f595e311d">   72</a></span>&#160;<a class="code" href="structchained__utf8doc__array__type.html">chained_utf8doc_array_type</a> <a class="code" href="recursive_hierarch_search_8hpp.html#ae01709f428082a54dabe6a9f595e311d">getVectorFromJSONStrGeneric</a>(std::string AddrStr,std::string key)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;{</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <a class="code" href="structchained__utf8doc__array__type.html">chained_utf8doc_array_type</a> collector;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(AddrStr);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    bsoncxx::document::element el = mdx_bdocview[key];</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keywordflow">if</span>(tp==bsoncxx::type::k_array)</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    {</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        bsoncxx::array::view vw = el.get_array();</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordtype">unsigned</span> elCntr=0;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">for</span>(bsoncxx::array::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        {</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;            elCntr++;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            <span class="keyword">auto</span> cur = *i;      </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keyword">enum</span> bsoncxx::type ar_el_tp = cur.type();                       </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_document)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            {</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;                std::string select = std::to_string(elCntr);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                bsoncxx::document::view mdx_buf = cur.get_document();</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;                {</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;                    <a class="code" href="structutf8__document__array__type.html">utf8_document_array_type</a> inner_vec;                    </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;                    <span class="keywordflow">for</span>(bsoncxx::document::view::const_iterator itin=mdx_buf.begin();itin!=mdx_buf.end();itin++)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;                    {                        </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;                        bsoncxx::document::element inel = *itin;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;                        <span class="keyword">enum</span> bsoncxx::type inel_tp = inel.type();                       </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;                        <span class="keywordflow">if</span>(inel.length()!=0)</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;                        {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;                            <span class="keywordflow">if</span>(inel_tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;                            {</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                                <a class="code" href="structutf8__document__type.html">utf8_document_type</a> result;                                </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;                                result.<a class="code" href="structutf8__document__type.html#a44cd9702f7da1032eb73d2cbba0b2172">key</a> = inel.key().to_string();    </div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                                result.<a class="code" href="structutf8__document__type.html#a293d926c3dedbf2179e331b39eda723a">value</a> = inel.get_utf8().value.to_string();                                   </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;                                inner_vec.<a class="code" href="structutf8__document__array__type.html#a248b65a1fe0fe9802d7c6cfe8f3a4eec">documents</a>.push_back(result);                                </div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;                            }</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;                        }</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;                    }</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;                    collector.<a class="code" href="structchained__utf8doc__array__type.html#a04fbde65e52c36fce726cb1476718171">documents_chain</a>.push_back(inner_vec);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;                }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            }            </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        }        </div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    } </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordflow">return</span> collector;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;}</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#a5e9719d81b3fbb25e5404193e66b94c9">  122</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="recursive_hierarch_search_8hpp.html#a5e9719d81b3fbb25e5404193e66b94c9">getVectorFromJSONStr</a>(std::string AddrStr,std::string key)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;{</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    std::vector&lt;std::string&gt; collector;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(AddrStr);</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    bsoncxx::document::element el = mdx_bdocview[key];</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordflow">if</span>(tp==bsoncxx::type::k_array)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    {</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        bsoncxx::array::view vw = el.get_array();</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordtype">unsigned</span> elCntr=0;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordflow">for</span>(bsoncxx::array::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            elCntr++;</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            <span class="keyword">auto</span> cur = *i;      </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;            <span class="keyword">enum</span> bsoncxx::type ar_el_tp = cur.type();                       </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_document)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                std::string select = std::to_string(elCntr);</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                bsoncxx::document::view mdx_buf = cur.get_document();</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                bsoncxx::document::element ar_el = mdx_buf[select];             </div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                <span class="keyword">enum</span> bsoncxx::type ar_el_tp = ar_el.type();                     </div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                <span class="keywordflow">if</span>(ar_el.length()!=0)</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                {</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                    <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                    {</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                        std::string result = ar_el.get_utf8().value.to_string();    </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;                        collector.push_back(result);</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                    }                        </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;                }    </div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            }</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;            <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                std::string result = cur.get_utf8().value.to_string();  </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                collector.push_back(result);</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;            }</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    } </div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="keywordflow">return</span> collector;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;}</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160; </div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160; </div>
<div class="line"><a name="l00167"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#a84e7a8d5a78c4f9d483ce3bf66b186ea">  167</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="recursive_hierarch_search_8hpp.html#a84e7a8d5a78c4f9d483ce3bf66b186ea">getAddrVec</a>(std::string AddrStr)</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;{</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    std::vector&lt;std::string&gt; collector;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(AddrStr);</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    bsoncxx::document::element el = mdx_bdocview[<span class="stringliteral">&quot;array_indices&quot;</span>];</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    </div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <span class="keywordflow">if</span>(tp==bsoncxx::type::k_array)</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    {</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        bsoncxx::array::view vw = el.get_array();</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordtype">unsigned</span> elCntr=0;</div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keywordflow">for</span>(bsoncxx::array::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        {</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            elCntr++;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            <span class="keyword">auto</span> cur = *i;      </div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            <span class="keyword">enum</span> bsoncxx::type ar_el_tp = cur.type();                       </div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_document)</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;            {</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                std::string select = std::to_string(elCntr);</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                bsoncxx::document::view mdx_buf = cur.get_document();</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                bsoncxx::document::element ar_el = mdx_buf[select];             </div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                <span class="keyword">enum</span> bsoncxx::type ar_el_tp = ar_el.type();                     </div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                {</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                    std::string result = ar_el.get_utf8().value.to_string();    </div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;                    collector.push_back(result);</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                }                        </div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;            }</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        }</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    } </div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordflow">return</span> collector;</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;}</div>
<div class="line"><a name="l00201"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#a7698b98c647502bfaa8d3f5f980a4db6">  201</a></span>&#160;std::vector&lt;std::string&gt; <a class="code" href="recursive_hierarch_search_8hpp.html#a7698b98c647502bfaa8d3f5f980a4db6">getValuesVec</a>(std::string AddrStr)</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;{</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    std::vector&lt;std::string&gt; collector;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    bsoncxx::document::value mdx_bdocval = bsoncxx::from_json(AddrStr);</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    bsoncxx::document::view mdx_bdocview = mdx_bdocval.view();</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    bsoncxx::document::element el = mdx_bdocview[<span class="stringliteral">&quot;values&quot;</span>];</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <span class="keyword">enum</span> bsoncxx::type tp = el.type();</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160; </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <span class="keywordflow">if</span>(tp==bsoncxx::type::k_array)</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    {</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        bsoncxx::array::view vw = el.get_array();</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordtype">unsigned</span> elCntr=0;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="keywordflow">for</span>(bsoncxx::array::view::iterator i=vw.begin();i!=vw.end();i++)</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        {</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            <span class="keyword">auto</span> cur = *i;      </div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;            <span class="keyword">enum</span> bsoncxx::type ar_el_tp = cur.type();                       </div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_document)</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            {</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                bsoncxx::document::view mdx_buf = cur.get_document();</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                std::string select = std::to_string(elCntr);</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                bsoncxx::document::element ar_el = mdx_buf[select];             </div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                elCntr++;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;                <span class="keyword">enum</span> bsoncxx::type ar_el_tp = ar_el.type();                     </div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;                <span class="keywordflow">if</span>(ar_el_tp==bsoncxx::type::k_utf8)</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;                {</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;                    std::string result = ar_el.get_utf8().value.to_string();    </div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;                    collector.push_back(result);</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;                }                        </div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;            }</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        }</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    } </div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <span class="keywordflow">return</span> collector;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;}</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160; </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="keywordtype">void</span> <a class="code" href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">recursiveVisitor</a>(bsoncxx::builder::basic::document&amp; MainNode,std::string&amp; ident,std::string name,std::string addr,std::vector&lt;std::string&gt;&amp; name_vec,std::string type);</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160; </div>
<div class="line"><a name="l00238"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">  238</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">recursiveVisitor</a>(bsoncxx::builder::basic::document&amp; MainNode,std::string&amp; ident,std::string name,std::string addr,std::vector&lt;std::string&gt;&amp; name_vec,std::string type = <span class="stringliteral">&quot;VARIABLE&quot;</span>)</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;{</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    name_vec.push_back(name);</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    std::string getVarsId_t = <span class="stringliteral">&quot;SELECT DISTINCT mdx  FROM public.flattenedmdx WHERE mdx @&gt; &#39;{\&quot;identifier\&quot;: \&quot;&quot;</span>+ident+<span class="stringliteral">&quot;\&quot;,\&quot;parent_index\&quot;:\&quot;&quot;</span>+addr+<span class="stringliteral">&quot;\&quot;}&#39;;&quot;</span>;</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    std::vector&lt;std::vector&lt;std::string&gt;&gt; resVarID_vec_t = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getVarsId_t);</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160; </div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    std::vector&lt;std::string&gt; mdx_raw_vec  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resVarID_vec_t,0);</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    </div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator adrRwIt = mdx_raw_vec.begin();adrRwIt != mdx_raw_vec.end();adrRwIt++)                        </div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        std::string curAdr = *adrRwIt;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        std::string name = <a class="code" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a>(curAdr,<span class="stringliteral">&quot;name&quot;</span>);        </div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        std::string identifier = ident;</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        std::vector&lt;std::string&gt; adresses_vec = <a class="code" href="recursive_hierarch_search_8hpp.html#a84e7a8d5a78c4f9d483ce3bf66b186ea">getAddrVec</a>(curAdr);                                </div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        std::vector&lt;std::string&gt; level_name_vec = name_vec;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        <span class="keywordflow">if</span>(adresses_vec.empty())</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        {</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            std::string index = <a class="code" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a>(curAdr,<span class="stringliteral">&quot;index&quot;</span>);</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            std::string parent_index =<a class="code" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a>(curAdr,<span class="stringliteral">&quot;parent_index&quot;</span>);</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160; </div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            std::vector&lt;std::string&gt; values = <a class="code" href="recursive_hierarch_search_8hpp.html#a7698b98c647502bfaa8d3f5f980a4db6">getValuesVec</a>(curAdr);</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            bsoncxx::builder::basic::array array_builder = bsoncxx::builder::basic::array{};</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator i=values.begin();i!=values.end();i++)</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            {</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                std::string val = *i;</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                array_builder.append(val);</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;            }</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            MainNode.append(kvp(<span class="stringliteral">&quot;values&quot;</span>,array_builder));</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            level_name_vec.push_back(name);</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            bsoncxx::builder::basic::array array_builder_nm = bsoncxx::builder::basic::array{};</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator i=level_name_vec.begin();i!=level_name_vec.end();i++)</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            {</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;                std::string val = *i;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;                array_builder_nm.append(val);</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;            </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;            }</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            MainNode.append(kvp(<span class="stringliteral">&quot;identifier&quot;</span>,ident));</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;            MainNode.append(kvp(<span class="stringliteral">&quot;index&quot;</span>,index));</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            MainNode.append(kvp(<span class="stringliteral">&quot;parent_index&quot;</span>,parent_index));            </div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            MainNode.append(kvp(<span class="stringliteral">&quot;hierarchy&quot;</span>,array_builder_nm));</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;            <span class="keywordflow">if</span>(type.compare(<span class="stringliteral">&quot;VARIABLE&quot;</span>)==0)</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            {</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;MDXVariables&quot;</span>,<span class="stringliteral">&quot;MDXVars&quot;</span>,MainNode.extract());     </div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            }</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            </div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            <span class="keywordflow">if</span>(type.compare(<span class="stringliteral">&quot;CALPARM&quot;</span>)==0)</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;            {</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;MDXCalibrationParms&quot;</span>,<span class="stringliteral">&quot;MDXCalParms&quot;</span>,MainNode.extract());     </div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            }  </div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160; </div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            <span class="keywordflow">if</span>(type.compare(<span class="stringliteral">&quot;SW-COMPU-METHOD&quot;</span>)==0)</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            {</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;MDXCompuMethods&quot;</span>,<span class="stringliteral">&quot;MDXCmpMths&quot;</span>,MainNode.extract());     </div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;            }            </div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            <span class="keywordflow">if</span>(type.compare(<span class="stringliteral">&quot;SW-UNIT&quot;</span>)==0)</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;            {</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;MDXSWUnits&quot;</span>,<span class="stringliteral">&quot;MDXUnits&quot;</span>,MainNode.extract());     </div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            }                        </div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;            <span class="keywordflow">if</span>(type.compare(<span class="stringliteral">&quot;SW-SYSTEMCONST&quot;</span>)==0)</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;            {</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;                <span class="keywordtype">bool</span> isInserted = <a class="code" href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,<span class="stringliteral">&quot;MDXSystemConstants&quot;</span>,<span class="stringliteral">&quot;MDXSysConsts&quot;</span>,MainNode.extract());     </div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;            }            </div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        }</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        {</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator adIt = adresses_vec.begin();adIt != adresses_vec.end();adIt++)</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;            {</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;                std::string addr = *adIt;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                <a class="code" href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">recursiveVisitor</a>(MainNode,ident,name,addr,name_vec,type);        </div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;                name_vec = level_name_vec;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;            }            </div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        }</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        </div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    }            </div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;}</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160; </div>
<div class="line"><a name="l00314"></a><span class="lineno"><a class="line" href="recursive_hierarch_search_8hpp.html#ae62f4ee8f8889d1dd6ad45a8ec04cdc3">  314</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="recursive_hierarch_search_8hpp.html#ae62f4ee8f8889d1dd6ad45a8ec04cdc3">visitSWVariables</a>(std::string ident)</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;{</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    std::vector&lt;std::string&gt; name_vec;</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    name_vec.push_back(<span class="stringliteral">&quot;SW-VARIABLES&quot;</span>);</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160; </div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    std::string getVarsId_t = <span class="stringliteral">&quot;SELECT mdx FROM public.flattenedmdx WHERE mdx @&gt; &#39;{\&quot;identifier\&quot;: \&quot;&quot;</span>+ident+<span class="stringliteral">&quot;\&quot;, \&quot;name\&quot;:\&quot;SW-VARIABLE\&quot;}&#39;;&quot;</span>;            </div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    std::vector&lt;std::vector&lt;std::string&gt;&gt; resVarID_vec_t = <a class="code" href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a>(<span class="stringliteral">&quot;ThermoBaseDataStationary&quot;</span>,getVarsId_t);</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        </div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    std::vector&lt;std::string&gt; mdx_raw_vec  = <a class="code" href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a>(resVarID_vec_t,0);</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;            </div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;    bsoncxx::builder::basic::document MainNode;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160; </div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator adrRwIt = mdx_raw_vec.begin();adrRwIt != mdx_raw_vec.end();adrRwIt++)                        </div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    {</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;        std::string curAdr = *adrRwIt;</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        </div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;        std::vector&lt;std::string&gt; addrvec = <a class="code" href="recursive_hierarch_search_8hpp.html#a84e7a8d5a78c4f9d483ce3bf66b186ea">getAddrVec</a>(curAdr);   </div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        std::string name = <a class="code" href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a>(curAdr,<span class="stringliteral">&quot;name&quot;</span>);</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        </div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;        </div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;        <span class="keywordflow">if</span>(!addrvec.empty())</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;        {</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;            <span class="keywordflow">for</span>(std::vector&lt;std::string&gt;::iterator adIt = addrvec.begin();adIt != addrvec.end();adIt++)</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;            {</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                std::vector&lt;std::string&gt; level_name_vec = name_vec;</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                std::string addr = *adIt;</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;                <a class="code" href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">recursiveVisitor</a>(MainNode,ident,name,addr,name_vec);                        </div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;                name_vec = level_name_vec;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            }          </div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        }</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                                      </div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    }        </div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="astructchained__utf8doc__array__type_html"><div class="ttname"><a href="structchained__utf8doc__array__type.html">chained_utf8doc_array_type</a></div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:67</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a5e9719d81b3fbb25e5404193e66b94c9"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a5e9719d81b3fbb25e5404193e66b94c9">getVectorFromJSONStr</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getVectorFromJSONStr(std::string AddrStr, std::string key)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:122</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a23641ff228bc4a84c18a7ae15c42ed77"><div class="ttname"><a href="postgres_interface_8hpp.html#a23641ff228bc4a84c18a7ae15c42ed77">genericQuery</a></div><div class="ttdeci">std::vector&lt; std::vector&lt; std::string &gt; &gt; genericQuery(std::string dbName, std::string query)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:759</div></div>
<div class="ttc" id="astructutf8__document__array__type_html"><div class="ttname"><a href="structutf8__document__array__type.html">utf8_document_array_type</a></div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:62</div></div>
<div class="ttc" id="astructutf8__document__type_html_a293d926c3dedbf2179e331b39eda723a"><div class="ttname"><a href="structutf8__document__type.html#a293d926c3dedbf2179e331b39eda723a">utf8_document_type::value</a></div><div class="ttdeci">std::string value</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:59</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a7698b98c647502bfaa8d3f5f980a4db6"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a7698b98c647502bfaa8d3f5f980a4db6">getValuesVec</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getValuesVec(std::string AddrStr)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:201</div></div>
<div class="ttc" id="astructchained__utf8doc__array__type_html_a04fbde65e52c36fce726cb1476718171"><div class="ttname"><a href="structchained__utf8doc__array__type.html#a04fbde65e52c36fce726cb1476718171">chained_utf8doc_array_type::documents_chain</a></div><div class="ttdeci">std::vector&lt; utf8_document_array_type &gt; documents_chain</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:69</div></div>
<div class="ttc" id="astructutf8__document__array__type_html_a248b65a1fe0fe9802d7c6cfe8f3a4eec"><div class="ttname"><a href="structutf8__document__array__type.html#a248b65a1fe0fe9802d7c6cfe8f3a4eec">utf8_document_array_type::documents</a></div><div class="ttdeci">std::vector&lt; utf8_document_type &gt; documents</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:64</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_ae62f4ee8f8889d1dd6ad45a8ec04cdc3"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#ae62f4ee8f8889d1dd6ad45a8ec04cdc3">visitSWVariables</a></div><div class="ttdeci">void visitSWVariables(std::string ident)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:314</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a50a5034e0f6e6d95d8d2a73f68c88668"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a50a5034e0f6e6d95d8d2a73f68c88668">recursiveVisitor</a></div><div class="ttdeci">void recursiveVisitor(bsoncxx::builder::basic::document &amp;MainNode, std::string &amp;ident, std::string name, std::string addr, std::vector&lt; std::string &gt; &amp;name_vec, std::string type)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:238</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_ae80795e0e8b8d7169f267438db1baa6b"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#ae80795e0e8b8d7169f267438db1baa6b">getScalar</a></div><div class="ttdeci">std::string getScalar(std::string AddrStr, std::string attr)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:40</div></div>
<div class="ttc" id="apostgres_interface_8hpp_html_a93a897241339ada0d6a3676765ae1d21"><div class="ttname"><a href="postgres_interface_8hpp.html#a93a897241339ada0d6a3676765ae1d21">insertOneIntoCollection</a></div><div class="ttdeci">bool insertOneIntoCollection(std::string dbName, std::string table, std::string column, bsoncxx::document::value doc_val)</div><div class="ttdef"><b>Definition:</b> postgresInterface.hpp:66</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_ae01709f428082a54dabe6a9f595e311d"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#ae01709f428082a54dabe6a9f595e311d">getVectorFromJSONStrGeneric</a></div><div class="ttdeci">chained_utf8doc_array_type getVectorFromJSONStrGeneric(std::string AddrStr, std::string key)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:72</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a6c3aafef43e91acd0d2542ea2c5337ac"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a6c3aafef43e91acd0d2542ea2c5337ac">getNthColumn</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getNthColumn(std::vector&lt; std::vector&lt; std::string &gt;&gt; matrix, unsigned colNo)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:24</div></div>
<div class="ttc" id="arecursive_hierarch_search_8hpp_html_a84e7a8d5a78c4f9d483ce3bf66b186ea"><div class="ttname"><a href="recursive_hierarch_search_8hpp.html#a84e7a8d5a78c4f9d483ce3bf66b186ea">getAddrVec</a></div><div class="ttdeci">std::vector&lt; std::string &gt; getAddrVec(std::string AddrStr)</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:167</div></div>
<div class="ttc" id="astructutf8__document__type_html_a44cd9702f7da1032eb73d2cbba0b2172"><div class="ttname"><a href="structutf8__document__type.html#a44cd9702f7da1032eb73d2cbba0b2172">utf8_document_type::key</a></div><div class="ttdeci">std::string key</div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:58</div></div>
<div class="ttc" id="astructutf8__document__type_html"><div class="ttname"><a href="structutf8__document__type.html">utf8_document_type</a></div><div class="ttdef"><b>Definition:</b> recursiveHierarchSearch.hpp:56</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="recursive_hierarch_search_8hpp.html">recursiveHierarchSearch.hpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
